# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ChannelAuditDetails(BaseModel):
    """
    The auditDetails object encapsulates channel data that is relevant for YouTube Partners during the audit process.
    """ # noqa: E501
    community_guidelines_good_standing: Optional[StrictBool] = Field(default=None, description="Whether or not the channel respects the community guidelines.", alias="communityGuidelinesGoodStanding")
    content_id_claims_good_standing: Optional[StrictBool] = Field(default=None, description="Whether or not the channel has any unresolved claims.", alias="contentIdClaimsGoodStanding")
    copyright_strikes_good_standing: Optional[StrictBool] = Field(default=None, description="Whether or not the channel has any copyright strikes.", alias="copyrightStrikesGoodStanding")
    __properties: ClassVar[List[str]] = ["communityGuidelinesGoodStanding", "contentIdClaimsGoodStanding", "copyrightStrikesGoodStanding"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ChannelAuditDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ChannelAuditDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "communityGuidelinesGoodStanding": obj.get("communityGuidelinesGoodStanding"),
            "contentIdClaimsGoodStanding": obj.get("contentIdClaimsGoodStanding"),
            "copyrightStrikesGoodStanding": obj.get("copyrightStrikesGoodStanding")
        })
        return _obj


