# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CuepointSchedule(BaseModel):
    """
    Schedule to insert cuepoints into a broadcast by ads automator.
    """ # noqa: E501
    enabled: Optional[StrictBool] = Field(default=None, description="This field is semantically required. If it is set false or not set, other fields in this message will be ignored.")
    pause_ads_until: Optional[StrictStr] = Field(default=None, description="If set, automatic cuepoint insertion is paused until this timestamp (\"No Ad Zone\"). The value is specified in ISO 8601 format.", alias="pauseAdsUntil")
    repeat_interval_secs: Optional[StrictInt] = Field(default=None, description="Interval frequency in seconds that api uses to insert cuepoints automatically.", alias="repeatIntervalSecs")
    schedule_strategy: Optional[StrictStr] = Field(default=None, description="The strategy to use when scheduling cuepoints.", alias="scheduleStrategy")
    __properties: ClassVar[List[str]] = ["enabled", "pauseAdsUntil", "repeatIntervalSecs", "scheduleStrategy"]

    @field_validator('schedule_strategy')
    def schedule_strategy_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['scheduleStrategyUnspecified', 'concurrent', 'nonConcurrent']):
            raise ValueError("must be one of enum values ('scheduleStrategyUnspecified', 'concurrent', 'nonConcurrent')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CuepointSchedule from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CuepointSchedule from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "enabled": obj.get("enabled"),
            "pauseAdsUntil": obj.get("pauseAdsUntil"),
            "repeatIntervalSecs": obj.get("repeatIntervalSecs"),
            "scheduleStrategy": obj.get("scheduleStrategy")
        })
        return _obj


