# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from abcdefgji_ti.models.channel_profile_details import ChannelProfileDetails
from typing import Optional, Set
from typing_extensions import Self

class LiveChatBanSnippet(BaseModel):
    """
    LiveChatBanSnippet
    """ # noqa: E501
    ban_duration_seconds: Optional[StrictStr] = Field(default=None, description="The duration of a ban, only filled if the ban has type TEMPORARY.", alias="banDurationSeconds")
    banned_user_details: Optional[ChannelProfileDetails] = Field(default=None, alias="bannedUserDetails")
    live_chat_id: Optional[StrictStr] = Field(default=None, description="The chat this ban is pertinent to.", alias="liveChatId")
    type: Optional[StrictStr] = Field(default=None, description="The type of ban.")
    __properties: ClassVar[List[str]] = ["banDurationSeconds", "bannedUserDetails", "liveChatId", "type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['liveChatBanTypeUnspecified', 'permanent', 'temporary']):
            raise ValueError("must be one of enum values ('liveChatBanTypeUnspecified', 'permanent', 'temporary')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LiveChatBanSnippet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of banned_user_details
        if self.banned_user_details:
            _dict['bannedUserDetails'] = self.banned_user_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LiveChatBanSnippet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "banDurationSeconds": obj.get("banDurationSeconds"),
            "bannedUserDetails": ChannelProfileDetails.from_dict(obj["bannedUserDetails"]) if obj.get("bannedUserDetails") is not None else None,
            "liveChatId": obj.get("liveChatId"),
            "type": obj.get("type")
        })
        return _obj


