# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from abcdefgji_ti.models.live_chat_message import LiveChatMessage
from abcdefgji_ti.models.page_info import PageInfo
from typing import Optional, Set
from typing_extensions import Self

class LiveChatMessageListResponse(BaseModel):
    """
    LiveChatMessageListResponse
    """ # noqa: E501
    active_poll_item: Optional[LiveChatMessage] = Field(default=None, alias="activePollItem")
    etag: Optional[StrictStr] = Field(default=None, description="Etag of this resource.")
    event_id: Optional[StrictStr] = Field(default=None, description="Serialized EventId of the request which produced this response.", alias="eventId")
    items: Optional[List[LiveChatMessage]] = None
    kind: Optional[StrictStr] = Field(default='youtube#liveChatMessageListResponse', description="Identifies what kind of resource this is. Value: the fixed string \"youtube#liveChatMessageListResponse\".")
    next_page_token: Optional[StrictStr] = Field(default=None, alias="nextPageToken")
    offline_at: Optional[datetime] = Field(default=None, description="The date and time when the underlying stream went offline.", alias="offlineAt")
    page_info: Optional[PageInfo] = Field(default=None, alias="pageInfo")
    polling_interval_millis: Optional[StrictInt] = Field(default=None, description="The amount of time the client should wait before polling again.", alias="pollingIntervalMillis")
    token_pagination: Optional[Dict[str, Any]] = Field(default=None, description="Stub token pagination template to suppress results.", alias="tokenPagination")
    visitor_id: Optional[StrictStr] = Field(default=None, description="The visitorId identifies the visitor.", alias="visitorId")
    __properties: ClassVar[List[str]] = ["activePollItem", "etag", "eventId", "items", "kind", "nextPageToken", "offlineAt", "pageInfo", "pollingIntervalMillis", "tokenPagination", "visitorId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LiveChatMessageListResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of active_poll_item
        if self.active_poll_item:
            _dict['activePollItem'] = self.active_poll_item.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in items (list)
        _items = []
        if self.items:
            for _item_items in self.items:
                if _item_items:
                    _items.append(_item_items.to_dict())
            _dict['items'] = _items
        # override the default output from pydantic by calling `to_dict()` of page_info
        if self.page_info:
            _dict['pageInfo'] = self.page_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LiveChatMessageListResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activePollItem": LiveChatMessage.from_dict(obj["activePollItem"]) if obj.get("activePollItem") is not None else None,
            "etag": obj.get("etag"),
            "eventId": obj.get("eventId"),
            "items": [LiveChatMessage.from_dict(_item) for _item in obj["items"]] if obj.get("items") is not None else None,
            "kind": obj.get("kind") if obj.get("kind") is not None else 'youtube#liveChatMessageListResponse',
            "nextPageToken": obj.get("nextPageToken"),
            "offlineAt": obj.get("offlineAt"),
            "pageInfo": PageInfo.from_dict(obj["pageInfo"]) if obj.get("pageInfo") is not None else None,
            "pollingIntervalMillis": obj.get("pollingIntervalMillis"),
            "tokenPagination": obj.get("tokenPagination"),
            "visitorId": obj.get("visitorId")
        })
        return _obj


