# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from abcdefgji_ti.models.live_stream_health_status import LiveStreamHealthStatus
from typing import Optional, Set
from typing_extensions import Self

class LiveStreamStatus(BaseModel):
    """
    Brief description of the live stream status.
    """ # noqa: E501
    health_status: Optional[LiveStreamHealthStatus] = Field(default=None, alias="healthStatus")
    stream_status: Optional[StrictStr] = Field(default=None, alias="streamStatus")
    __properties: ClassVar[List[str]] = ["healthStatus", "streamStatus"]

    @field_validator('stream_status')
    def stream_status_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['created', 'ready', 'active', 'inactive', 'error']):
            raise ValueError("must be one of enum values ('created', 'ready', 'active', 'inactive', 'error')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LiveStreamStatus from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of health_status
        if self.health_status:
            _dict['healthStatus'] = self.health_status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LiveStreamStatus from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "healthStatus": LiveStreamHealthStatus.from_dict(obj["healthStatus"]) if obj.get("healthStatus") is not None else None,
            "streamStatus": obj.get("streamStatus")
        })
        return _obj


