# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from abcdefgji_ti.models.resource_id import ResourceId
from abcdefgji_ti.models.thumbnail_details import ThumbnailDetails
from typing import Optional, Set
from typing_extensions import Self

class PlaylistItemSnippet(BaseModel):
    """
    Basic details about a playlist, including title, description and thumbnails. Basic details of a YouTube Playlist item provided by the author. Next ID: 15
    """ # noqa: E501
    channel_id: Optional[StrictStr] = Field(default=None, description="The ID that YouTube uses to uniquely identify the user that added the item to the playlist.", alias="channelId")
    channel_title: Optional[StrictStr] = Field(default=None, description="Channel title for the channel that the playlist item belongs to.", alias="channelTitle")
    description: Optional[StrictStr] = Field(default=None, description="The item's description.")
    playlist_id: Optional[StrictStr] = Field(default=None, description="The ID that YouTube uses to uniquely identify thGe playlist that the playlist item is in.", alias="playlistId")
    position: Optional[StrictInt] = Field(default=None, description="The order in which the item appears in the playlist. The value uses a zero-based index, so the first item has a position of 0, the second item has a position of 1, and so forth.")
    published_at: Optional[datetime] = Field(default=None, description="The date and time that the item was added to the playlist.", alias="publishedAt")
    resource_id: Optional[ResourceId] = Field(default=None, alias="resourceId")
    thumbnails: Optional[ThumbnailDetails] = None
    title: Optional[StrictStr] = Field(default=None, description="The item's title.")
    video_owner_channel_id: Optional[StrictStr] = Field(default=None, description="Channel id for the channel this video belongs to.", alias="videoOwnerChannelId")
    video_owner_channel_title: Optional[StrictStr] = Field(default=None, description="Channel title for the channel this video belongs to.", alias="videoOwnerChannelTitle")
    __properties: ClassVar[List[str]] = ["channelId", "channelTitle", "description", "playlistId", "position", "publishedAt", "resourceId", "thumbnails", "title", "videoOwnerChannelId", "videoOwnerChannelTitle"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PlaylistItemSnippet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of resource_id
        if self.resource_id:
            _dict['resourceId'] = self.resource_id.to_dict()
        # override the default output from pydantic by calling `to_dict()` of thumbnails
        if self.thumbnails:
            _dict['thumbnails'] = self.thumbnails.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PlaylistItemSnippet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "channelId": obj.get("channelId"),
            "channelTitle": obj.get("channelTitle"),
            "description": obj.get("description"),
            "playlistId": obj.get("playlistId"),
            "position": obj.get("position"),
            "publishedAt": obj.get("publishedAt"),
            "resourceId": ResourceId.from_dict(obj["resourceId"]) if obj.get("resourceId") is not None else None,
            "thumbnails": ThumbnailDetails.from_dict(obj["thumbnails"]) if obj.get("thumbnails") is not None else None,
            "title": obj.get("title"),
            "videoOwnerChannelId": obj.get("videoOwnerChannelId"),
            "videoOwnerChannelTitle": obj.get("videoOwnerChannelTitle")
        })
        return _obj


