# coding: utf-8

"""
    YouTube Data API v3

    The YouTube Data API v3 is an API that provides access to YouTube data, such as videos, playlists, and channels.

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from abcdefgji_ti.models.video_abuse_report_secondary_reason import VideoAbuseReportSecondaryReason
from typing import Optional, Set
from typing_extensions import Self

class VideoAbuseReportReasonSnippet(BaseModel):
    """
    Basic details about a video category, such as its localized title.
    """ # noqa: E501
    label: Optional[StrictStr] = Field(default=None, description="The localized label belonging to this abuse report reason.")
    secondary_reasons: Optional[List[VideoAbuseReportSecondaryReason]] = Field(default=None, description="The secondary reasons associated with this reason, if any are available. (There might be 0 or more.)", alias="secondaryReasons")
    __properties: ClassVar[List[str]] = ["label", "secondaryReasons"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VideoAbuseReportReasonSnippet from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in secondary_reasons (list)
        _items = []
        if self.secondary_reasons:
            for _item_secondary_reasons in self.secondary_reasons:
                if _item_secondary_reasons:
                    _items.append(_item_secondary_reasons.to_dict())
            _dict['secondaryReasons'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VideoAbuseReportReasonSnippet from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "label": obj.get("label"),
            "secondaryReasons": [VideoAbuseReportSecondaryReason.from_dict(_item) for _item in obj["secondaryReasons"]] if obj.get("secondaryReasons") is not None else None
        })
        return _obj


